/* ------------------------------------------------------------------------- *
 * Cavalin Alberto | Matr. 472802 | Esercizio numero 1 | PC039 | 25/Ott/2002 *
 * ------------------------------------------------------------------------- */


// [ Librerie delle funzioni di sistema ] ------------------------------------
#include <iostream.h>
#include <fstream.h>
// ---------------------------------------------------------------------------


// [ Prototipi delle funzioni usate ] ----------------------------------------
int    leggi_dati     (double vett[]);
int    scrivi_su_file (char nomefile[],double vett[],int l);
int    leggi_da_file  (char nomefile[],double vett[]);
double calcola_somma  (double vett[],int l);
// ---------------------------------------------------------------------------


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * MAIN: Funzione principale                                                 *
 * I : \   | \                                                               *
 * O : int | codice di uscita del programma                                  *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
int main() {
    // [ Punto 1 ] -----------------------------------------------------------
    cout<<"----- Lettura dei dati da tastiera -----\n";
    double vett[100];       //array che conterra' la serie di dati reali
    int l;                  //numero di dati da leggere
    l=leggi_dati(vett);     //lettura dei dati e loro inserimento nell'array

    // [ Punto 2 ] -----------------------------------------------------------
    cout<<"\n----- Lettura del nome del file da tastiera -----\n";
    char nomefile[256];     //variabile che conterra' il nome del file
    cout<<"Dammi il nome del file su cui salvare i dati: ";
    cin>>nomefile;

    // [ Punto 3 ] -----------------------------------------------------------
    cout<<"\n----- Scrittura dei dati in un file -----\n";
    if (scrivi_su_file(nomefile,vett,l)) { //salvataggio dei dati su file   
        cout<<"Errore nella creazione del file per il salvataggio dei dati!";
        return -1;
    }//if

    // [ Punto 4 ] -----------------------------------------------------------
    cout<<"\n----- Lettura dei dati dal file -----\n";
    for (int i=0;i<l;i++)   //azzeramento del vettore per il suo riutilizzo
        vett[i]=0;          //per accertarmi della corretta lettura da file
    l=leggi_da_file(nomefile,vett); //lettura dei dati dal file creato
    //se il numero di dati letti e' negativo, il file non e' stato aperto
    if (l<0) {
        cout<<"Errore nella lettura del file dei dati!";
        return -2;
    }//if
    
    // [ Punto 5 ] -----------------------------------------------------------
    cout<<"\n----- Calcolo della somma dei dati -----\n";
    double sum; //variabile che conterra' la somma dei dati letti
    sum=calcola_somma(vett,l);      //calcolo della somma dei dati
    cout<<"La sommma dei dati e': "<<sum;

    // [ Fine del programma ] ------------------------------------------------
    return 0;
}//main ----------------------------------------------------------------------


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * LEGGI_DATI: Legge i dati da testiera e li inserisce nell'array            *
 * I : vett | array nel quale inserire i dati                                *
 * O : n    | numero di elementi letti                                       *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
int leggi_dati(double vett[]) {
    int n,  //numero elementi da leggere
        i;  //variabile contatore
    cout<<"Dammi il numero di elementi che vuoi inserire (max 100): ";
    cin>>n; //lettura del numero elementi da leggere
    for (i=0;i<n;i++) { //lettura dei dati
        cout<<"Dammi l'elemento numero "<<i+1<<": ";
        cin>>vett[i];   //inserimento dei dati nel vettore
    }//for
    return n; //restituzione del numero di elementi letti
}//leggi_dati ----------------------------------------------------------------


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * SCRIVI_SU_FILE: Salva i dati dell'array nel file specificato              *
 * I1: nomefile | nome del file da scrivere                                  *
 * I2: vett     | array dei dati da salvare                                  *
 * I3: n        | numero di dati inseriti nell'array                         *
 * O : int      | codice d'uscita: 0=OK, -1=Errore apertura file             *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
int scrivi_su_file(char nomefile[],double vett[],int n) {
    fstream dati; //dichiarazione della variabile per la gestione del file
    dati.open(nomefile,ios::out); //apertura del file in scrittura
    if (!dati)    //se non riesce ad aprire il file ritorna un codice d'errore
        return -1;
    for (int i=0;i<n;i++)         //salvataggio dei dati nel file
        dati<<vett[i]<<" ";
    dati.close(); //chiusura del file
    return 0;
}//scrivi_su_file ------------------------------------------------------------


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * LEGGI_DA_FILE: Legge i dati dal file                                      *
 * I1: nomefile | nome del file da leggere                                   *
 * I2: vett     | array nel quale inserire i dati letti                      *
 * O : int      | numero dati letti (-1 in caso di errore)                   *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
int leggi_da_file(char nomefile[],double vett[]) {
    fstream dati; //dichiarazione della variabile per la gestione del file
    dati.open(nomefile,ios::in); //apertura del file in lettura
    if (!dati)    //se non riesce ad aprire il file ritorna un codice d'errore
        return -1;
    int i=0;
    while (!dati.eof()) {        //leggi finche' non termina il file
        dati>>vett[i];           //salvataggio del dato nel vettore
        i++;
    }//while
    dati.close(); //chiusura del file
    return i-1;   //restituzione del numero di elementi letti
}//leggi_da_file -------------------------------------------------------------


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * CALCOLA_SOMMA: Calcola la somma dei dati inseriti nel vettore             *
 * I1: vett | array dei dati                                                 *
 * I2: l    | numero di dati inseriti nell'array                             *
 * O : s    | somma dei dati                                                 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
double calcola_somma(double vett[],int l) {
    if (l==1)
        return vett[0];
    else
        return vett[0]+calcola_somma(&vett[1],l-1);
}//calcola_somma -------------------------------------------------------------
