/* ------------------------------------------------------------------------- *
 * Cavalin Alberto | Matr. 472802 | Esercizio numero 1 | PC032 | 08/Nov/2002 *
 * ------------------------------------------------------------------------- */

// [ Librerie delle funzioni di sistema ] ------------------------------------
#include <iostream.h>                   //gestione dell'I/O
#include <fstream.h>                    //gestione dei file
#include <iomanip.h>                    //manipolazione dell'I/O
#include <stdlib.h>                     //gestione del processo
// ---------------------------------------------------------------------------

// [ Defines, macro, pragma, ecc...     ] ------------------------------------
#define clrscr() system("cls")          //cancellazione dello schermo
#define N_S      100                    //numero massimo di studenti
#define N_L      35                     //lunghezza massima di un nome
// ---------------------------------------------------------------------------

// [ Strutture, var enumerative, ecc... ] ------------------------------------
enum BOOL { FALSE, TRUE };              //var booleana
// ---------------------------------------------------------------------------

// [ Prototipi delle funzioni usate     ] ------------------------------------
void f_open            (char nome[],fstream *file,BOOL read);
int  leggi_nomi_e_voti (char nomi[][N_L],int voti[]);
void salva_valori      (char nomi[][N_L],int voti[],int n);
void stampa_classifica (int  voti[],int n);
// ---------------------------------------------------------------------------

/* ------------------------------------------------------------------------- *
 * MAIN: Funzione principale                                                 *
 * I : \   | \                                                               *
 * O : int | codice di uscita del programma                                  *
 * ------------------------------------------------------------------------- */
int main() {
    clrscr();                           //pulitura dello schermo

    // [ dichiarazione delle variabili     ] ---------------------------------
    char nomi[N_S][N_L];                //matrice dei nomi
    int  voti[N_S],                     //array dei voti
         n;                             //numero di studenti letti

    // [ lettura dei dati                  ] ---------------------------------
    cout<<"----- [ Lettura dei dati dai file  ] -----\n";
    n=leggi_nomi_e_voti(nomi,voti);     //lettura dei dati dai file

    // [ scrittura dei dati su file        ] ---------------------------------
    cout<<"\n----- [ Scrittura dei dati su file ] -----\n";
    salva_valori(nomi,voti,n);          //salva gli studenti con voto >= 18

    // [ classificazione dei voti          ] ---------------------------------
    cout<<"\n----- [ Classificazione dei dati   ] -----\n";
    stampa_classifica(voti,n);          //stampa la classifica dei dati

    // [ programma terminato correttamente ] ---------------------------------
    return 0;
}//main ----------------------------------------------------------------------

/* ------------------------------------------------------------------------- *
 * F_OPEN: Apre un file eseguendo i dovuti controlli                         *
 * I1: nome | nome del file da aprire                                        *
 * I2: file | stream del file                                                *
 * I3: read | tipo di streaming: lettura/scrittura                           *
 * O : \    | \                                                              *
 * ------------------------------------------------------------------------- */
void f_open(char nome[],fstream *file,BOOL read) {
    file->open(nome,(read?(ios::in):(ios::out)));
    if (!(*file)) { //se il file non e' stato aperto correttamente
        cout<<"Errore nell'apertura del file \""<<nome<<"\"!\n";
        exit(-1);
    }//if
}//f_open --------------------------------------------------------------------

/* ------------------------------------------------------------------------- *
 * LEGGI_NOMI_E_VOTI: Legge i dati dai file e li salva negli array           *
 * I1: nomi | array multidimensionale dei i nomi degli studenti              *
 * I2: voti | array dei voti degli studenti                                  *
 * O : n    | numero di studenti letti                                       *
 * ------------------------------------------------------------------------- */
int leggi_nomi_e_voti(char nomi[][N_L],int voti[]) {
    // [ dichiarazione delle variabili     ] ---------------------------------
    int n=0;                            //variabile contatore
    fstream fnomi,fvoti;                //variabili per la gestione dei file

    // [ apertura dei file in lettura      ] ---------------------------------
    f_open("nomi.txt",&fnomi,TRUE);
    f_open("voto.txt",&fvoti,TRUE);

    // [ lettura dei dati dai file         ] ---------------------------------
    while (!fnomi.eof()&&!fvoti.eof()) {//leggi finche' non terminano i file
        fnomi.getline(nomi[n],N_S-1,'\n');  //lettura del nome
        fvoti>>voti[n];                     //lettura del voto
        n++;
    }//while

    // [ ritorno del numero di studenti    ] ---------------------------------
    return n-1;
}//leggi_nomi_e_voti

/* ------------------------------------------------------------------------- *
 * SALVA_VALORI: Salva i dati degli studenti sufficienti su un file          *
 * I1: nomi | array multidimensionale dei i nomi degli studenti              *
 * I2: voti | array dei voti degli studenti                                  *
 * I3: n    | numero di studenti                                             *
 * O : \    | \                                                              *
 * ------------------------------------------------------------------------- */
void salva_valori(char nomi[][N_L],int voti[],int n) {
    // [ dichiarazione delle variabili     ] ---------------------------------
    char nomef[256];                    //nome del file
    fstream fout;                       //variabile per la gestione del file

    // [ lettura del nome del file         ] ---------------------------------
    cout<<"Dammi il nome dei file sul quale scrivere i dati: ";
    cin>>nomef;

    // [ apertura e scrittura del file ] ---------------------------------
    f_open(nomef,&fout,FALSE);          //apertura in scrittura del file
    for (int i=0;i<n;i++)               //stampa degli studenti con voto >=18
        fout<<(voti[i]>=18?nomi[i]:"")<<(voti[i]>=18?"\n":"");
}//salva_valori

/* ------------------------------------------------------------------------- *
 * STAMPA_CLASSIFICA: Classifica i dati e stampa le frequenze a video        *
 * I1: voti | array dei voti degli studenti                                  *
 * I2: n    | numero di studenti                                             *
 * O : \    | \                                                              *
 * ------------------------------------------------------------------------- */
void stampa_classifica(int voti[],int n) {
    // [ dichiarazione delle variabili     ] ---------------------------------
    int freq[3];                        //vettore delle freq. delle 3 classi
    freq[0]=freq[1]=freq[2]=0;          //azzeramento delle frequanze

    // [ analisi dei voti/lettura freq.    ] ---------------------------------
    for (int i=0;i<n;i++)               //incremento della corrispettiva classe
        freq[(voti[i]<18?0:(voti[i]<=24?1:2))]++;

    // [ stampa a video dei dati             ] ---------------------------------
    cout<<"+-----------+-----------+-----------+\n";
    cout<<"|   < 18    |  18 - 24  |   > 24    |\n";
    cout<<"+-----------+-----------+-----------+\n";
    cout<<"|"<<setw(10)<<freq[0]<<' ';
    cout<<"|"<<setw(10)<<freq[1]<<' ';
    cout<<"|"<<setw(10)<<freq[2]<<" |\n";
    cout<<"|___________|___________|___________|\n";
}//stampa_classifica
