/* ------------------------------------------------------------------------- *
 * Cavalin Alberto | Matr. 472802 | Esercizio numero 2 | PC032 | 15/Nov/2002 *
 * ------------------------------------------------------------------------- */

// [ Librerie delle funzioni di sistema ] ------------------------------------
#include <iostream.h>                   //gestione dell'I/O
#include <fstream.h>                    //gestione dei file
#include <iomanip.h>                    //manipolazione dell'I/O
#include <stdlib.h>                     //gestione del processo
#include <string.h>                     //gestione delle stringhe
// ---------------------------------------------------------------------------

// [ Defines, macro, pragma, ecc...     ] ------------------------------------
#define clrscr() system("cls")          //cancellazione dello schermo
#define NC 300                          //numero massimo di codici inseriti
#define LC 10                           //lunghezza massima di un codice
// ---------------------------------------------------------------------------

// [ Strutture, var enumerative, ecc... ] ------------------------------------
enum BOOL { FALSE, TRUE };              //var booleana
// ---------------------------------------------------------------------------

// [ Prototipi delle funzioni usate     ] ------------------------------------
void f_open        (char nome[],fstream *file,BOOL read);
int  leggi_dati    (char cod[][LC],int qt[]);
void print_results (char cod[][LC],int qt[],int n,char cod_ut[]);
// ---------------------------------------------------------------------------

/* ------------------------------------------------------------------------- *
 * MAIN: Funzione principale                                                 *
 * I : \   | \                                                               *
 * O : int | codice di uscita del programma                                  *
 * ------------------------------------------------------------------------- */
int main() {
    clrscr();                           //pulitura dello schermo

    // [ dichiarazione delle variabili     ] ---------------------------------
    char cod[NC][LC];                   //codici dei prodotti
    int  qt[NC];                        //quantita' dei prodotti

    // [ lettura dei dati dal file         ] ---------------------------------
    cout<<"----- [ lettura dei dati dal file ] -----"<<endl;
    int n;                              //numero di codici letti
    n=leggi_dati(cod,qt);               //scrittura dei dati negli array

    // [ analisi dei dati letti            ] ---------------------------------
    cout<<"----- [ analisi dei dati letti    ] -----"<<endl;
    char cod_ut[LC];                    //codice inserito dall'utente
    cout<<"Dammi il codice da cercare: ";
    cin>>cod_ut;                        //lettura del codice da cercare
    print_results(cod,qt,n,cod_ut);     //calcola e stampa il risultato

    // [ programma terminato correttamente ] ---------------------------------
    return 0;
}//main ----------------------------------------------------------------------

/* ------------------------------------------------------------------------- *
 * F_OPEN: Apre un file eseguendo i dovuti controlli                         *
 * I1: nome | nome del file da aprire                                        *
 * I2: file | stream del file                                                *
 * I3: read | tipo di streaming: lettura/scrittura                           *
 * O : \    | \                                                              *
 * ------------------------------------------------------------------------- */
void f_open(char nome[],fstream *file,BOOL read) {
    file->open(nome,(read?(ios::in):(ios::out)));
    if (!(*file)) { //se il file non e' stato aperto correttamente
        cout<<"Errore nell'apertura del file \""<<nome<<"\"!\n";
        exit(-1);
    }//if
}//f_open --------------------------------------------------------------------

/* ------------------------------------------------------------------------- *
 * LEGGI_DATI: Apre il file "prodotti.txt" e ne legge i dati contenuti       *
 * I1: cod | codici letti                                                    *
 * I2: qt  | quantita' lette                                                 *
 * O : int | numero di codici letti                                          *
 * ------------------------------------------------------------------------- */
int leggi_dati(char cod[][LC],int qt[]) {
    // [ apertura del file dei dati        ] ---------------------------------
    fstream fin;                        //stream del file di dati
    f_open("prodotti.txt",&fin,TRUE);   //apertura del file dei dati

    // [ lettura dei dati negli array      ] ---------------------------------
    int i=0;
    do {
        fin>>cod[i];                    //lettura codice
        fin>>qt[i];                     //lettura quantita'
        i++;
    }while (!fin.eof());
    fin.close();                        //chiusura dello stream dei dati

    return i-1;                         //ritorno del numero di codici letti
}//leggi_dati

/* ------------------------------------------------------------------------- *
 * PRINT_RESULTS: Calcola e stampa i risultati della ricerca                 *
 * I1: cod    | codici letti                                                 *
 * I2: qt     | quantita' lette                                              *
 * I3: n      | numero di codici letti                                       *
 * I4: cod_ut | codice inserito da ricercare                                 *
 * O : \      | \                                                            *
 * ------------------------------------------------------------------------- */
void print_results(char cod[][LC],int qt[],int n,char cod_ut[]) {
    // [ dichiarazione delle variabili     ] ---------------------------------
    int qt_tot=0;                       //quantita' totale venduta
    int n_ord=0;                        //numero di vendite totale

    // [ controllo dei dati                ] ---------------------------------
    for (int i=0;i<n;i++)               //per ogni elemento letto
        if (!stricmp(cod[i],cod_ut)) {  //se i codici coincidono
            n_ord++;                    //incremento delle vendite
            qt_tot+=qt[i];              //incremento della qt. totale
        }//if

    // [ stampa dei risultati a video      ] ---------------------------------
    cout<<endl;
    if (n_ord) {                        //se l'articolo esiste
        cout<<"Totale vendite per l'articolo '"<<cod_ut<<"': "<<n_ord<<endl;
        cout<<"Totale quantita' venduta: "<<qt_tot<<endl;
    }//if
    else
        cout<<"Spiacente ma l'articolo selezionato non e' mai stato venduto!";
}//print_results

