/* ------------------------------------------------------------------------- *
 * Cavalin Alberto | Matr. 472802 | Esercizio numero 1 | PC032 | 07/Nov/2002 *
 * ------------------------------------------------------------------------- */

// [ Librerie delle funzioni di sistema ] ------------------------------------
#include <iostream.h>
#include <fstream.h>
#include <iomanip.h>
#include <string.h>
#include <stdlib.h>
// ---------------------------------------------------------------------------

// [ Defines, macro, ecc...             ] ------------------------------------
#define clrscr() system("cls")
#define NS 300                          //numero massimo di studenti
#define LN 30                           //lunghezza massima del nome
// ---------------------------------------------------------------------------

// [ Strutture, var enumerative, ecc... ] ------------------------------------
enum BOOL { FALSE, TRUE };              //var booleana
// ---------------------------------------------------------------------------

// [ Prototipi delle funzioni usate     ] ------------------------------------
void f_open(char nome[],fstream *file,BOOL read);
void ordina_stud(char nome[][LN],int n);
// ---------------------------------------------------------------------------

/* ------------------------------------------------------------------------- *
 * MAIN: Funzione principale                                                 *
 * I : \   | \                                                               *
 * O : int | codice di uscita del programma                                  *
 * ------------------------------------------------------------------------- */
int main() {
    clrscr();               //pulitura dello schermo

    //dichiarazione delle variabili
    char nome[NS][LN],      //stringa per i nomi
         tmp[10];           //stringa temporanea
    int n=0;                //variabile contatore del numero di studenti
    fstream fin,fout;       //streams per la manipolazione dei dati   

    //apertura dei file per la gestione dei dati
    f_open("studenti.txt",&fin,TRUE);   //apertura file dei nomi

    //lettura dei nomi dal file
    cout<<"----- [ lettura dei nomi dal file ] -----\n";
    while (!fin.eof()) {                //leggi finche' non termina il file
        fin.getline(nome[n],29,'\t');   //lettura del nome
        if (strlen(nome[n])>1) {        //controllo di non leggere un '\n'
            n++;                        //incremento il contatore dei voti
            fin.getline(tmp,29,'\n');   //eliminazione del '\n'
        }//if
    }//while
    fin.close();                        //chiusura del file di input

    cout<<"----- [ ordinamento in corso      ] -----\n";
    ordina_stud(nome,n);                //ordinamento degli studenti

    f_open("stud_sort.txt",&fout,FALSE);  //apertura file di output

    cout<<"----- [ salvataggio dei nomi      ] -----\n";
    for (int j=0;j<n;j++)
        fout<<nome[j]<<"\n";
    fout.close();                       //chiusura del file di output

    return 0;
}//main ----------------------------------------------------------------------

/* ------------------------------------------------------------------------- *
 * F_OPEN: Apre un file eseguendo i dovuti controlli                         *
 * I1: nome | nome del file da aprire                                        *
 * I2: file | stream del file                                                *
 * I3: read | tipo di streaming: lettura/scrittura                           *
 * O : \    | \                                                              *
 * ------------------------------------------------------------------------- */
void f_open(char nome[],fstream *file,BOOL read) {
    file->open(nome,(read?(ios::in):(ios::out)));
    if (!(*file)) { //se il file non e' stato aperto correttamente
        cout<<"Errore nell'apertura del file \""<<nome<<"\"!\n";
        exit(-1);
    }//if
}//f_open --------------------------------------------------------------------

/* ------------------------------------------------------------------------- *
 * ORDINA_STUD: Ordina i nomi degli studenti                                 *
 * I1: nome | nomi dei profressori                                           *
 * I2: n    | numero di studenti                                             *
 * O : \    | \                                                              *
 * ------------------------------------------------------------------------- */
void ordina_stud(char nome[][LN],int n) {
    int i,j;
    char swap[LN];
    for (i=0;i<n;i++)
        for (j=i+1;j<n;j++)
            if (strcmp(nome[i],nome[j])>0) {
                strcpy(swap,nome[i]);
                strcpy(nome[i],nome[j]);
                strcpy(nome[j],swap);
            }//if
}//ordina_stud ---------------------------------------------------------------
