/* ------------------------------------------------------------------------- *
 * Cavalin Alberto | Matr. 472802 | Esercizio numero 1 | PC032 | 07/Nov/2002 *
 * ------------------------------------------------------------------------- */

// [ Librerie delle funzioni di sistema ] ------------------------------------
#include <iostream.h>
#include <fstream.h>
#include <iomanip.h>
#include <string.h>
#include <stdlib.h>
// ---------------------------------------------------------------------------

// [ Defines, macro, ecc...             ] ------------------------------------
#define clrscr() system("cls")
#define NS 300                          //numero massimo di studenti
#define LN 30                           //lunghezza massima del nome
// ---------------------------------------------------------------------------

// [ Strutture, var enumerative, ecc... ] ------------------------------------
enum BOOL { FALSE, TRUE };              //var booleana
// ---------------------------------------------------------------------------

// [ Prototipi delle funzioni usate     ] ------------------------------------
void f_open(char nome[],fstream *file,BOOL read);
void ordina_stud(char nome[][LN],int voto[],int n);
// ---------------------------------------------------------------------------

/* ------------------------------------------------------------------------- *
 * MAIN: Funzione principale                                                 *
 * I : \   | \                                                               *
 * O : int | codice di uscita del programma                                  *
 * ------------------------------------------------------------------------- */
int main() {
    clrscr();               //pulitura dello schermo

    //dichiarazione delle variabili
    char nome[NS][LN],      //stringa per i nomi
         tmp[10];           //stringa temporanea
    int  n=0,               //variabile contatore del numero di studenti
		 voto[NS];			//voti degli studenti
    fstream fn,fv,fout;     //streams per la manipolazione dei dati   

    //apertura dei file per la gestione dei dati
    f_open("nomi.txt",&fn,TRUE);		//apertura file dei nomi
    f_open("voto.txt",&fv,TRUE);		//apertura file dei voti

    //lettura dei nomi dal file
    cout<<"----- [ lettura dei dati dai file ] -----\n";
    while (!fn.eof()&&!fv.eof()) {      //leggi finche' non termina il file
        fn.getline(nome[n],29,'\n');    //lettura del nome
		fv>>voto[n];					//lettura del voto
		n++;							//incremento il contatore dei voti
    }//while
	n--;								//decremento il numero di elem di 1
    fn.close();                         //chiusura del file dei nomi
    fv.close();                         //chiusura del file dei voti

    cout<<"----- [ ordinamento in corso      ] -----\n";
    ordina_stud(nome,voto,n);           //ordinamento degli studenti

    cout<<"----- [ salvataggio dei nomi      ] -----\n";
    f_open("studenti.txt",&fout,FALSE); //apertura file di output
    for (int i=0;i<n;i++)
        fout<<setiosflags(ios::left)<<setw(LN)<<nome[i]<<setw(5)<<voto[i]<<"\n";
    fout.close();                       //chiusura del file di output

    return 0;
}//main ----------------------------------------------------------------------

/* ------------------------------------------------------------------------- *
 * F_OPEN: Apre un file eseguendo i dovuti controlli                         *
 * I1: nome | nome del file da aprire                                        *
 * I2: file | stream del file                                                *
 * I3: read | tipo di streaming: lettura/scrittura                           *
 * O : \    | \                                                              *
 * ------------------------------------------------------------------------- */
void f_open(char nome[],fstream *file,BOOL read) {
    file->open(nome,(read?(ios::in):(ios::out)));
    if (!(*file)) { //se il file non e' stato aperto correttamente
        cout<<"Errore nell'apertura del file \""<<nome<<"\"!\n";
        exit(-1);
    }//if
}//f_open --------------------------------------------------------------------

/* ------------------------------------------------------------------------- *
 * ORDINA_STUD: Ordina i nomi degli studenti                                 *
 * I1: nome | nomi degli studenti                                            *
 * I2: voto | voti degli studenti                                            *
 * I3: n    | numero di studenti                                             *
 * O : \    | \                                                              *
 * ------------------------------------------------------------------------- */
void ordina_stud(char nome[][LN],int voto[],int n) {
    int i,j,v;
    char swap[LN];
    for (i=0;i<n;i++)
        for (j=i+1;j<n;j++)
            if (strcmp(nome[i],nome[j])>0) {
				//spostamento nome
                strcpy(swap,nome[i]);
                strcpy(nome[i],nome[j]);
                strcpy(nome[j],swap);
				//spostamento voto
				v=voto[i];
				voto[i]=voto[j];
				voto[j]=v;
            }//if
}//ordina_stud ---------------------------------------------------------------
