/* ------------------------------------------------------------------------- *
 * Cavalin Alberto | Matr. 472802 | Esercizio numero 1 | PC032 | 07/Nov/2002 *
 * ------------------------------------------------------------------------- */


// [ Librerie delle funzioni di sistema ] ------------------------------------
#include <iostream.h>
#include <fstream.h>
#include <iomanip.h>
#include <stdlib.h>
// ---------------------------------------------------------------------------


// [ Defines, macro, ecc...             ] ------------------------------------
#define clrscr() system("cls")

enum BOOL { FALSE, TRUE };
// ---------------------------------------------------------------------------


// [ Prototipi delle funzioni usate     ] ------------------------------------
void f_open(char nome[],fstream *file,BOOL read);
void write_diff(fstream *fmin,fstream *fmax,fstream *fout);
void write_max_min(fstream *fin,fstream *fout);
// ---------------------------------------------------------------------------


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * MAIN: Funzione principale                                                 *
 * I : \   | \                                                               *
 * O : int | codice di uscita del programma                                  *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
int main() {
    clrscr();                         //pulitura dello schermo
    fstream fmin,fmax,fin,fout;       //streams per la manipolazione dei dati   

    // [ calcolo delle differenze di temperatura ] ---------------------------
    cout<<" --- calcolo delle differenze di temperatura --- "<<endl;
    f_open("minime.dat",&fmin,TRUE);  //apertura file delle temperature minime
    f_open("massime.dat",&fmax,TRUE); //apertura file delle temperature massime
    f_open("diff.dat",&fout,FALSE);   //apertura file delle differenze
    write_diff(&fmin,&fmax,&fout);    //scrittura delle differenze su file
    //chiusura degli stream usati
    fmin.close();
    fmax.close();
    fout.close();

    // [ calcolo della media per ogni riga ] ---------------------------------
    cout<<" --- calcolo del massimo e minimo per ogni riga --- "<<endl;
    f_open("diff.dat",&fin,TRUE);        //apertura file delle differenze
    f_open("min_max.dat",&fout,FALSE);   //apertura file delle medie
    write_max_min(&fin,&fout);           //scrittura delle medie su file
    
	// [ programma terminato correttamente ] ---------------------------------
    return 0;
}//main


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * F_OPEN: Apre un file eseguendo i dovuti controlli                         *
 * I1: nome | nome del file da aprire                                        *
 * I2: file | stream del file                                                *
 * I3: read | tipo di streaming: lettura/scrittura                           *
 * O : \    | \                                                              *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
void f_open(char nome[],fstream *file,BOOL read) {
    file->open(nome,(read?(ios::in):(ios::out)));
    if (!(*file)) { //se il file non e' stato aperto correttamente
        cout<<"Errore nell'apertura del file \""<<nome<<"\"!\n";
        exit(-1);
    }//if
}//f_open

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * WRITE_DIFF: Legge le temperatura e salva la differenza in un altro file   *
 * I1: fmin | stream delle temperature minime                                *
 * I2: fmax | stream delle temperature massime                               *
 * I3: fout | stream delle differenze                                        *
 * O : \    | \                                                              *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
void write_diff(fstream *fmin,fstream *fmax,fstream *fout) {
    int r,c,t1,t2;
    *fmin>>r>>c;    //lettura delle righe e delle colonne da fmin
    *fmax>>r>>c;    //lettura delle righe e delle colonne da fmax
    *fout<<r<<" "<<c<<endl;
    for (int i=0;i<r;i++) {
        for (int j=0;j<c;j++) {
            *fmax>>t2;              //lettura t max
            *fmin>>t1;              //lettura t min
            *fout<<(t2-t1)<<"\t";   //scrittura della differenza
        }//for
        *fout<<endl;                //ritorno a capo
    }//for
}//write_diff

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * WRITE_MAX_MIN: Scrive su file le temperatura massime e minime             *
 * I1: fin  | stream delle temperature in ingresso                           *
 * I2: fout | stream delle temperature medie in uscita                       *
 * O : \    | \                                                              *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
void write_max_min(fstream *fin,fstream *fout) {
    int r,c,min,max,tmp;
    *fin>>r>>c;    //lettura delle righe e delle colonne da fin
    *fout<<r<<" "<<2<<endl;
    for (int i=0;i<r;i++) {
        *fin>>tmp;                      //lettura temperatura
        min=max=tmp;
        for (int j=1;j<c;j++) {
            *fin>>tmp;                  //lettura temperatura
            min=(tmp<min?tmp:min);      //sostituzione del minimo
            max=(tmp>max?tmp:max);      //sostituzione del massimo
        }//for
        *fout<<min<<'\t'<<max<<endl;    //stampa media
    }//for
}//write_max_min
