/* ------------------------------------------------------------------------- *
 * Cavalin Alberto | Matr. 472802 | Esercizio numero 1 | PC032 | 31/Ott/2002 *
 * ------------------------------------------------------------------------- */


// [ Librerie delle funzioni di sistema ] ------------------------------------
#include <iostream.h>
#include <fstream.h>
#include <iomanip.h>
#include <stdlib.h>
// ---------------------------------------------------------------------------


// [ Defines, macro, ecc...             ] ------------------------------------
#define clrscr() system("cls")
// ---------------------------------------------------------------------------


// [ Prototipi delle funzioni usate     ] ------------------------------------
void make_file  (fstream * file);
void store_data (fstream * file);
// ---------------------------------------------------------------------------


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * MAIN: Funzione principale                                                 *
 * I : \   | \                                                               *
 * O : int | codice di uscita del programma                                  *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
int main() {
    clrscr();                //pulitura dello schermo
    fstream dati_stud;       //stream per la gestione dei dati degli studenti
    make_file (&dati_stud);  //creazione del file
    store_data (&dati_stud); //lettura dei dati e loro memorizzazione nel file
    dati_stud.close();       //chiusura dello stream dei dati degli studenti
    return 0;                //fine programma
}//main

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * MAKE_FILE: Crea il file eseguendo i relativi controlli                    *
 * I : file | stream del file da creare                                      *
 * O : \    | \                                                              *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
void make_file (fstream * file) {
	char nome_file[255];
	cout<<"Dammi il nome del file sul quale scrivere i dati: ";
	cin.getline(nome_file,254,'\n');  //lettura del nome del file da creare
	(*file).open(nome_file,ios::out); //apertura del file in scrittura
	if (!(*file)) {
        cout<<"Errore nella creazione del file per il salvataggio dei dati!";
        exit(-1);
	}//if
}//make_file

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * STORE_DATA: Legge i dati da testiera e li inserisce nel file              *
 * I : file | stream del file nel quale salvare i dati                       *
 * O : \    | \                                                              *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
void store_data (fstream * file) {
	char nome[41];	//nome dello studente
	char voto[3];	//voto dello studente
	while (!cin.eof()) { //leggi finche' l'utente non preme ^Z
		cout<<"Dammi il nome dello studente: ";
		cin.getline(nome,40,'\n');  //lettura del nome dello studente
		cout<<"Dammi il voto dello studente: ";
		cin.getline(voto,2,'\n');	//lettura del voto dello studente
		(*file)<<"|"<<setw(45)<<nome<<" |"<<setw(5)<<voto<<" |\n";
		cout<<"\n";
	}//while
}//store_data 
